//: C05:StaticAssert2.cpp {-g++}
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
#include <iostream>
using namespace std;

// Šablona a specializace
template<bool> struct StatickaKontrola {
  StatickaKontrola(...);
};

template<> struct StatickaKontrola<false> {};

// Makro (generuje lokální třídu)
#define STATIC_CHECK(expr, msg) {             \
  class Chyba_##msg {};                       \
  sizeof((StatickaKontrola<expr>(Error_##msg()))); \
}

// Zjištění ztrátových konverzí
template<class Na, class Z> Na safe_cast(Z z) {
  STATIC_CHECK(sizeof(Z) <= sizeof(Na),
               ZtratovaKonverze);
  return reinterpret_cast<Na>(z);
}

int main() {
  void* p = 0;
  int i = safe_cast<int>(p);
  cout << "přetypování na int je OK" << endl;
  //! char c = safe_cast<char>(p);
} ///:~
